% %[o,menino,comeu,o,bolo]
% s(sn(d(o),n(menino)),sv(v(comeu),sn(d(o),n(bolo))))
sentenca( s( SN, SV ) ) -->
	sintagma_nominal( SN, Numero ),
	sintagma_verbal( SV, Numero ).

sintagma_nominal( sn( D, N ), Numero ) -->
	determinante( D , Genero, Numero ),
	nome( N ,Genero, Numero ).

sintagma_verbal( sv( V, SN ), Numero ) -->
	verbo_transitivo( V, Numero ),
	sintagma_nominal( SN, _ ).

% Léxico
determinante( d( X ) , G, N ) --> [X], {det(X, G,N)}.

det( a, feminino, s ).
det( o, masculino, s ).
det( um, masculino, s ).
det( uma, feminino, s ).
det( as, feminino, p ).
det( os, masculino, p ).

verbo_transitivo( vt( V), N ) --> [V],{vt(V,N)}.

vt( comeu, s ).
vt(comeram, p ).

nome( n( N ), G, Num ) --> [N],{nome(N,G,Num)}.

nome( menino, masculino, s ).
nome( meninos, masculino, p ).
%nome( bolo, masculino ).
nome( torta, feminino, s ).
nome( tortas, feminino, p ).

imprime_arvore( A ) :-
	imprime_arvore( A, 0 ).

imprime_arvore( A, N ) :-
	A =.. [ X | As ],
	tab( N ),
	write( X ),
	nl,
	N1 is N+2,
	imprime_lista( As, N1 ).

imprime_lista( [], _ ).
imprime_lista( [ A | As ], N ) :-
	imprime_arvore( A, N ),
	imprime_lista( As, N ).

