% %[o,menino,comeu,o,bolo]
% s(sn(d(o),n(menino)),sv(v(comeu),sn(d(o),n(bolo))))
sentenca( s( SN, SV ) ) -->
	sintagma_nominal( SN, Numero ),
	sintagma_verbal( SV, Numero ).

% O Emprego de resto_sn é  para evitar o loop infito formado pela
% recursão "pela cabeça:
% sn --> det, n.
% sn --> sn, sp.  %!!! esse é o caso problemático.
%
% A proposta a seguir evita o loop infinito
sintagma_nominal( SN, Numero ) -->
	determinante( D , Genero, Numero ),
	nome( N ,Genero, Numero ),
    resto_sn( SN, sn( D, N ) ).  % Decide se o sn termina aqui ou continua

resto_sn( SN, SN ) --> [].       % sn termina imediatamente
resto_sn( sn( SN, SP ), SN ) --> % sp modifica o sn
    sintagma_prep( SP ).

sintagma_verbal( SV, Numero ) -->
	verbo_transitivo( V, Numero ),
	sintagma_nominal( SN, _ ),
    resto_sv( SV, sv( V, SN ) ). % Decide se o sv termina aqui cou continua

resto_sv( SV, SV ) --> [].       % sv termina imediatamente
resto_sv( sv( SV, SP ), SV ) --> % sp modifica o sv
    sintagma_prep( SP ).

sintagma_prep( sp( P, SN ) ) -->
    prep( P  ),
    sintagma_nominal( SN, _ ).

% Léxico
determinante( d( X ) , G, N ) --> [X], {det(X, G, N)}.

det( a, feminino, s ).
det( o, masculino, s ).
det( um, masculino, s ).
det( uma, feminino, s ).
det( as, feminino, p ).
det( os, masculino, p ).

verbo_transitivo( vt( V), N ) --> [V],{vt(V,N)}.

vt( comeu, s ).
vt(comeram, p ).
vt( viu, s ).
vt( viram, p ).

nome( n( N ), G, Num ) --> [N],{nome(N,G,Num)}.

nome( menino, masculino, s ).
nome( meninos, masculino, p ).
nome( bolo, masculino, s ).
nome( torta, feminino, s ).
nome( tortas, feminino, p ).
nome( 'telescópio', masculino, s ).
nome( 'telescópios', masculino, p ).

prep( p(P) ) --> [P],{lista_de_preps(Ps),member(P, Ps)}.

lista_de_preps([com,de]).


imprime_arvore( A ) :-
	imprime_arvore( A, 0 ).

imprime_arvore( A, N ) :-
	A =.. [ X | As ],
	tab( N ),
	write( X ),
	nl,
	N1 is N+2,
	imprime_lista( As, N1 ).

imprime_lista( [], _ ).
imprime_lista( [ A | As ], N ) :-
	imprime_arvore( A, N ),
	imprime_lista( As, N ).

